<template>
  <el-form
    :model="routeForm"
    status-icon
    :rules="rules"
    ref="routeForm"
    label-width="120px"
  >
    <el-form-item required label="Departure city" prop="cityA">
      <el-input v-model.trim="routeForm.cityA"></el-input>
    </el-form-item>

    <el-form-item required label="Destination city" prop="cityB">
      <el-input v-model.trim="routeForm.cityB"></el-input>
    </el-form-item>

    <el-form-item required label="Distance, km" prop="distance">
      <el-input v-model.number="routeForm.distance"></el-input>
    </el-form-item>

    <el-form-item required label="Expected revenue, $" prop="expected_revenue">
      <el-input v-model.number="routeForm.expected_revenue"></el-input>
    </el-form-item>

    <el-form-item required label="Car type" prop="car_type_id">
      <el-select
        v-model="routeForm.car_type_id"
        placeholder="Choose required car type"
      >
        <el-option label="Passenger" :value="0"></el-option>
        <el-option label="Freight" :value="1"></el-option>
      </el-select>
    </el-form-item>

    <el-form-item label="Dispatch date" prop="date_start">
      <el-date-picker
        v-model="routeForm.date_start"
        type="datetime"
        placeholder="Select date and time"
      >
      </el-date-picker>
    </el-form-item>

    <el-form-item>
      <el-button type="primary" @click="postRoute">Save</el-button>
    </el-form-item>
  </el-form>
</template>

<script>
  import routeModelMixin from "@/mixins/routeModelMixin";
  import { ACTIONS_SAVE_ROUTE } from "@/plugins/constants";
  import { mapActions } from "vuex";

  export default {
    mixins: [routeModelMixin],
    data() {
      return {};
    },
    methods: {
      ...mapActions({ ACTIONS_SAVE_ROUTE }),
      async postRoute() {
        await this.$refs["routeForm"].validate();

        this.ACTIONS_SAVE_ROUTE(this.routeForm)
          .then(({ data }) => {
            this.$router.push({
              name: "Route", params: { id: data.insertId },
            });
            this.$notify.success({ message: "Successfully added route" });
          })
          .catch((error) => this.$notify.error({ message: error.response.data }));
      },
    },
  };
</script>

<style>
  .error {
    color: tomato;
  }

  .el-input {
    margin: 3px;
    padding: 5px;
  }
</style>